---
title: 'Element: mousemove event'
slug: Web/API/Element/mousemove_event
tags:
  - API
  - DOM
  - Event
  - Interface
  - MouseEvent
  - Reference
  - mouse
  - mousemove
  - move
  - pointer
---
<p>{{APIRef}}</p>

<p><span class="seoSummary">The <code>mousemove</code> event is fired at an element when a pointing device (usually a mouse) is moved while the cursor's hotspot is inside it.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MouseEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onmousemove", "onmousemove")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>The following example uses the {{domxref("Element/mousedown_event", "mousedown")}}, <code>mousemove</code>, and {{domxref("Element/mouseup_event", "mouseup")}} events to allow the user to draw on an HTML5 <a href="/en-US/docs/Web/API/Canvas_API">canvas</a>. Its functionality is simple: the thickness of the line is set to 1, and the color is always black.</p>

<p>When the page loads, constants <code>myPics</code> and <code>context</code> are created to store a reference to the canvas and the 2d context we will use to draw.</p>

<p>Drawing begins when the <code>mousedown</code> event fires. First we store the x and y coordinates of the mouse pointer in the variables <code>x</code> and <code>y</code>, and then set <code>isDrawing</code> to true.</p>

<p>As the mouse moves over the page, the <code>mousemove</code> event fires. If <code>isDrawing</code> is true, the event handler calls the <code>drawLine</code> function to draw a line from the stored <code>x</code> and <code>y</code> values to the current location.</p>

<p>When the <code>drawLine()</code> function returns, we adjust the coordinates and then save them in <code>x</code> and <code>y</code>.</p>

<p>The <code>mouseup</code> event draws the final line segment, sets <code>x</code> and <code>y</code> to <code>0</code>, and stops further drawing by setting <code>isDrawing</code> to <code>false</code>.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;h1&gt;Drawing with mouse events&lt;/h1&gt;
&lt;canvas id="myPics" width="560" height="360"&gt;&lt;/canvas&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">canvas {
  border: 1px solid black;
  width: 560px;
  height: 360px;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">// When true, moving the mouse draws on the canvas
let isDrawing = false;
let x = 0;
let y = 0;

const myPics = document.getElementById('myPics');
const context = myPics.getContext('2d');

// event.offsetX, event.offsetY gives the (x,y) offset from the edge of the canvas.

// Add the event listeners for mousedown, mousemove, and mouseup
myPics.addEventListener('mousedown', e =&gt; {
  x = e.offsetX;
  y = e.offsetY;
  isDrawing = true;
});

myPics.addEventListener('mousemove', e =&gt; {
  if (isDrawing === true) {
    drawLine(context, x, y, e.offsetX, e.offsetY);
    x = e.offsetX;
    y = e.offsetY;
  }
});

window.addEventListener('mouseup', e =&gt; {
  if (isDrawing === true) {
    drawLine(context, x, y, e.offsetX, e.offsetY);
    x = 0;
    y = 0;
    isDrawing = false;
  }
});

function drawLine(context, x1, y1, x2, y2) {
  context.beginPath();
  context.strokeStyle = 'black';
  context.lineWidth = 1;
  context.moveTo(x1, y1);
  context.lineTo(x2, y2);
  context.stroke();
  context.closePath();
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples", 640, 450)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('UI Events', '#event-type-mousemove', 'mousemove')}}</td>
   <td>{{Spec2('UI Events')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Events', '#event-type-mousemove', 'mousemove')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.mousemove_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/JavaScript/Building_blocks/Events">Introduction to events</a></li>
 <li>{{domxref("Element/mousedown_event", "mousedown")}}</li>
 <li>{{domxref("Element/mouseup_event", "mouseup")}}</li>
 <li>{{domxref("Element/click_event", "click")}}</li>
 <li>{{domxref("Element/dblclick_event", "dblclick")}}</li>
 <li>{{domxref("Element/mouseover_event", "mouseover")}}</li>
 <li>{{domxref("Element/mouseout_event", "mouseout")}}</li>
 <li>{{domxref("Element/mouseenter_event", "mouseenter")}}</li>
 <li>{{domxref("Element/mouseleave_event", "mouseleave")}}</li>
 <li>{{domxref("Element/contextmenu_event", "contextmenu")}}</li>
</ul>
